/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEF_MENU
#define DEF_MENU

#include <SFML/Graphics.hpp>
#include <string>
#include <vector>
#include "extlibs/TinyXML/tinyxml.h"

//Class managing a list of Buttons to make a menu.
class Menu : public sf::Drawable
{
    public:
        bool loadData(const std::string &xmlPath);
        
        virtual void launch() = 0;
        virtual void update(const sf::Vector2f &mousePosition, bool mouseClicked) = 0;
        
        virtual bool browsed() const = 0;
        virtual const std::vector<std::string> &result() const = 0;
        
        virtual float getWidth() const = 0;
        virtual float getHeight() const = 0;
        
    protected:
        void resetCurrentElement();
        virtual void Render(sf::RenderTarget& target, sf::Renderer& renderer) const = 0;
        
        TiXmlDocument m_xmlFile;
        TiXmlElement *m_currentElement;
};

#endif